Index: apps/app_chanspy.c
===================================================================
--- apps/app_chanspy.c	(revision 101267)
+++ apps/app_chanspy.c	(working copy)
@@ -242,6 +242,9 @@
 		ast_audiohook_init(&csth.whisper_audiohook, AST_AUDIOHOOK_TYPE_WHISPER, "ChanSpy");
 		start_spying(spyee, chan, &csth.whisper_audiohook);
 	}
+
+	/* Once all the audiohooks are attached to the channel release the lock so it can continue on it's way */
+	ast_channel_unlock(spyee);
 	
 	csth.volfactor = *volfactor;
 	
@@ -357,9 +360,10 @@
 		this = ast_channel_walk_locked(last);
 
 	if (this) {
-		ast_channel_unlock(this);
-		if (!strncmp(this->name, "Zap/pseudo", 10))
+		if (!strncmp(this->name, "Zap/pseudo", 10)) {
+			ast_channel_unlock(this);
 			goto redo;
+		}
 	}
 
 	return this;
@@ -419,17 +423,25 @@
 			int x;
 			char *s;
 				
-			if (peer == prev)
+			if (peer == prev) {
+				ast_channel_unlock(peer);
 				break;
+			}
 
-			if (peer == chan)
+			if (peer == chan) {
+				ast_channel_unlock(peer);
 				continue;
+			}
 
-			if (ast_test_flag(flags, OPTION_BRIDGED) && !ast_bridged_channel(peer))
+			if (ast_test_flag(flags, OPTION_BRIDGED) && !ast_bridged_channel(peer)) {
+				ast_channel_unlock(peer);
 				continue;
+			}
 
-			if (ast_check_hangup(peer) || ast_test_flag(peer, AST_FLAG_SPYING))
+			if (ast_check_hangup(peer) || ast_test_flag(peer, AST_FLAG_SPYING)) {
+				ast_channel_unlock(peer);
 				continue;
+			}
 
 			if (mygroup) {
 				if ((group = pbx_builtin_getvar_helper(peer, "SPYGROUP"))) {
@@ -446,8 +458,10 @@
 				}
 			}
 			
-			if (!igrp)
+			if (!igrp) {
+				ast_channel_unlock(peer);
 				continue;
+			}
 
 			strcpy(peer_name, "spy-");
 			strncat(peer_name, peer->name, AST_NAME_STRLEN);
